# class String::Builder

- String::Builder
- IO
- Reference
- Object

##
Overview

Similar to `IO::Memory`, but optimized for building a single string.

You should never have to deal with this class. Instead, use `String.build`.

##
Defined in:

string/builder.cr

##
Constructors

- .new(capacity : Int = 64)
- .new(string : String)

##
Class Method Summary

- .build(capacity : Int = 64, &) : String

##
Instance Method Summary

- #back(amount : Int) : Int32

  Moves the write pointer, and the resulting string bytesize, by the given amount.

- #buffer : Pointer(UInt8)
- #bytesize : Int32
- #capacity : Int32
- #chomp!(byte : UInt8) : self

  Chomps the last byte from the string buffer.

- #empty? : Bool
- #read(slice : Bytes) : NoReturn

  Reads at most slice.size bytes from this `IO` into slice.

- #set_encoding(encoding : String, invalid : Symbol | Nil = nil) : Nil

  Sets the encoding of this `IO`.

- #to_s : String

  Returns a nicely readable and concise string representation of this object, typically intended for users.

- #write(slice : Bytes) : Nil

  Writes the contents of slice into this `IO`.

- #write_byte(byte : UInt8) : Nil

  Writes a single byte into this `IO`.

- #write_string(slice : Bytes) : Nil

  Writes the contents of slice, interpreted as a sequence of UTF-8 or ASCII characters, into this `IO`.

### Instance methods inherited from class `IO`

<<(obj) : self <<, close close, closed? : Bool closed?, each_byte(&) : Nil
each_byte each_byte, each_char(&) : Nil
each_char each_char, each_line(*args, **options, &block : String -> ) : Nil
each_line(*args, **options) each_line, encoding : String encoding, flush flush, getb_to_end : Bytes getb_to_end, gets(limit : Int, chomp = false) : String | Nil
gets(delimiter : Char, limit : Int, chomp = false) : String | Nil
gets(delimiter : Char, chomp = false) : String | Nil
gets(delimiter : String, chomp = false) : String | Nil
gets(chomp = true) : String | Nil gets, gets_to_end : String gets_to_end, peek : Bytes | Nil peek, pos pos, pos=(value) pos=, print(obj : _) : Nil
print(*objects : _) : Nil print, printf(format_string, args : Array | Tuple) : Nil
printf(format_string, *args) : Nil printf, puts(string : String) : Nil
puts(obj : _) : Nil
puts : Nil
puts(*objects : _) : Nil puts, read(slice : Bytes) read, read_at(offset, bytesize, & : IO -> ) read_at, read_byte : UInt8 | Nil read_byte, read_bytes(type, format : IO::ByteFormat = IO::ByteFormat::SystemEndian) read_bytes, read_char : Char | Nil read_char, read_fully(slice : Bytes) : Int32 read_fully, read_fully?(slice : Bytes) : Int32 | Nil read_fully?, read_line(*args, **options) : String read_line, read_string(bytesize : Int) : String read_string, read_utf8(slice : Bytes) read_utf8, read_utf8_byte : UInt8 | Nil read_utf8_byte, rewind rewind, seek(offset, whence : Seek = Seek::Set) seek, set_encoding(encoding : String, invalid : Symbol | Nil = nil) : Nil set_encoding, skip(bytes_count : Int) : Nil skip, skip_to_end : Nil skip_to_end, tell tell, tty? : Bool tty?, write(slice : Bytes) : Nil write, write_byte(byte : UInt8) : Nil write_byte, write_bytes(object, format : IO::ByteFormat = IO::ByteFormat::SystemEndian) : Nil write_bytes, write_string(slice : Bytes) : Nil write_string, write_utf8(slice : Bytes) : Nil write_utf8

### Class methods inherited from class `IO`

copy(src, dst, limit : Int) : Int64
copy(src, dst) : Int64 copy, pipe(read_blocking = false, write_blocking = false) : Tuple(IO::FileDescriptor, IO::FileDescriptor)
pipe(read_blocking = false, write_blocking = false, &) pipe, same_content?(stream1 : IO, stream2 : IO) : Bool same_content?

### Instance methods inherited from class `Reference`

==(other : self)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup, hash(hasher) hash, initialize initialize, inspect(io : IO) : Nil inspect, object_id : UInt64 object_id, pretty_print(pp) : Nil pretty_print, same?(other : Reference) : Bool
same?(other : Nil) same?, to_s(io : IO) : Nil to_s

### Constructor methods inherited from class `Reference`

new new, unsafe_construct(address : Pointer, *args, **opts) : self unsafe_construct

### Class methods inherited from class `Reference`

pre_initialize(address : Pointer) pre_initialize

### Instance methods inherited from class `Object`

! : Bool !, !=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, as(type : Class) as, as?(type : Class) as?, class class, dup dup, hash(hasher)
hash hash, in?(collection : Object) : Bool
in?(*values : Object) : Bool in?, inspect(io : IO) : Nil
inspect : String inspect, is_a?(type : Class) : Bool is_a?, itself itself, nil? : Bool nil?, not_nil!(message)
not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, responds_to?(name : Symbol) : Bool responds_to?, tap(&) tap, to_json(io : IO) : Nil
to_json : String to_json, to_pretty_json(indent : String = " ") : String
to_pretty_json(io : IO, indent : String = " ") : Nil to_pretty_json, to_s(io : IO) : Nil
to_s : String to_s, to_yaml(io : IO) : Nil
to_yaml : String to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io, root : String)
from_json(string_or_io) from_json, from_yaml(string_or_io : String | IO) from_yaml

### Macros inherited from class `Object`

class_getter(*names, &block) class_getter, class_getter!(*names) class_getter!, class_getter?(*names, &block) class_getter?, class_property(*names, &block) class_property, class_property!(*names) class_property!, class_property?(*names, &block) class_property?, class_setter(*names) class_setter, def_clone def_clone, def_equals(*fields) def_equals, def_equals_and_hash(*fields) def_equals_and_hash, def_hash(*fields) def_hash, delegate(*methods, to object) delegate, forward_missing_to(delegate) forward_missing_to, getter(*names, &block) getter, getter!(*names) getter!, getter?(*names, &block) getter?, property(*names, &block) property, property!(*names) property!, property?(*names, &block) property?, setter(*names) setter

##
Constructor Detail

def self.new(capacity : Int = 64) #
def self.new(string : String) #

##
Class Method Detail

def self.build(capacity : Int = 64, &) : String #

##
Instance Method Detail

def back(amount : Int) : Int32 #

Moves the write pointer, and the resulting string bytesize, by the given amount.

def buffer : Pointer(UInt8) #
def bytesize : Int32 #
def capacity : Int32 #
def chomp!(byte : UInt8) : self #

Chomps the last byte from the string buffer. If the byte is `'\n'` and there's a `'\r'` before it, it is also removed.

def empty? : Bool #
def read(slice : Bytes) : NoReturn #
Description copied from class IO

Reads at most slice.size bytes from this `IO` into slice. Returns the number of bytes read, which is 0 if and only if there is no more data to read (so checking for 0 is the way to detect end of file).

    io = IO::Memory.new "hello"
    slice = Bytes.new(4)
    io.read(slice) # => 4
    slice          # => Bytes[104, 101, 108, 108]
    io.read(slice) # => 1
    slice          # => Bytes[111, 101, 108, 108]
    io.read(slice) # => 0

def set_encoding(encoding : String, invalid : Symbol | Nil = nil) : Nil #
Description copied from class IO

Sets the encoding of this `IO`.

The invalid argument can be:

- `nil`: an exception is raised on invalid byte sequences
- `:skip`: invalid byte sequences are ignored

String operations (`gets`, `gets_to_end`, `read_char`, `<<`, `print`, `puts` `printf`) will use this encoding.

def to_s : String #
Description copied from class Object

Returns a nicely readable and concise string representation of this object, typically intended for users.

This method should usually not be overridden. It delegates to `#to_s(IO)` which can be overridden for custom implementations.

Also see `#inspect`.

def write(slice : Bytes) : Nil #
Description copied from class IO

Writes the contents of slice into this `IO`.

    io = IO::Memory.new
    slice = Bytes.new(4) { |i| ('a'.ord + i).to_u8 }
    io.write(slice)
    io.to_s # => "abcd"

def write_byte(byte : UInt8) : Nil #
Description copied from class IO

Writes a single byte into this `IO`.

    io = IO::Memory.new
    io.write_byte 97_u8
    io.to_s # => "a"

def write_string(slice : Bytes) : Nil #
Description copied from class IO

Writes the contents of slice, interpreted as a sequence of UTF-8 or ASCII characters, into this `IO`. The contents are transcoded into this `IO`'s current encoding.

    bytes = "你".to_slice # => Bytes[228, 189, 160]

    io = IO::Memory.new
    io.set_encoding("GB2312")
    io.write_string(bytes)
    io.to_slice # => Bytes[196, 227]

    "你".encode("GB2312") # => Bytes[196, 227]